# jaguar_resty

Build fluent functional Restful clients

# Features

+ Fluent API to set:
    + [X] Hierarchical paths
    + [X] Query parameters
    + [X] Headers
    + [X] Body
    + [X] Client
+ [X] JSON request encoding
+ [X] JSON request decoding
+ [X] URL encoded forms
+ [X] Multipart form
+ [ ] Cookie jar
+ [ ] Interceptors
+ [ ] Authenticators

# Usage

## Simple GET request

```dart
Book book = await resty.get('/book/1').fetch(Book.map);
```

## Add query parameters

```dart
Book book = await resty.get('/book').query('page', '2').fetchList(Book.map);
```

## Add headers

```dart
Book book = await resty.get('/book').header('page', '2').fetch(Book.map);
```

## JSON request encoding

```dart
Book book = await resty.post('/book').json(new Book('1', 'Harry potter'))
  .fetch(Book.map);
```

## JSON response decoding

```dart
Book book = await resty.get('/book/1').fetch(Book.map);
```

## URL encoded forms

```dart
// TODO WIP
```

## Multipart form

```dart
// TODO WIP
```